Index: /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/writediagspecVI.F	(revision 1529)
@@ -43,9 +43,8 @@
 ! Addition by RW (2010) to allow OSR to be saved in .nc format
       use radinc_h, only : L_NSPECTV
-!      USE surfdat_h
-#ifdef CPP_PARA
+      use comgeomphy, only: airephy
       use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather
-      use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
-#endif
+      use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo,
+     &                              nbp_lon, nbp_lat
       use time_phylmdz_mod, only: ecritphy, iphysiq, day_step, day_ini
       use callkeys_mod, only: iradia
@@ -53,11 +52,5 @@
       implicit none
 
-! Commons
-#include "dimensions.h"
-!#include "dimphys.h"
-#include "paramet.h"
-!#include "control.h"
-#include "comgeom.h"
-#include "netcdf.inc"
+      include "netcdf.inc"
 
 ! Arguments on input:
@@ -73,8 +66,4 @@
 !      real dx0
 
-      real date
-
-!      REAL phis(ip1jmp1)
-
       integer irythme
       integer ierr
@@ -82,11 +71,7 @@
       integer i,j,l,zmax , ig0
 
-      integer zitau
-      character firstnom*20
-      SAVE firstnom
-      SAVE zitau
-      SAVE date
-      data firstnom /'1234567890'/
-      data zitau /0/
+      integer,save :: zitau=0
+      character(len=20),save :: firstnom='1234567890'
+      real,save :: date
 !$OMP THREADPRIVATE(firstnom,zitau,date)
 
@@ -100,14 +85,15 @@
       integer, dimension(4) :: edges,corner
 
+      real area((nbp_lon+1),nbp_lat)
 ! added by RDW for OSR output
-       real dx3(iip1,jjp1,L_NSPECTV) ! to store the data set
+       real dx3(nbp_lon+1,nbp_lat,L_NSPECTV) ! to store the data set
 
 #ifdef CPP_PARA
 ! Added to work in parallel mode
       real dx3_glop(klon_glo,L_NSPECTV)
-      real dx3_glo(iim,jjp1,L_NSPECTV) ! to store a global 3D data set
-#else
-      logical,parameter :: is_master=.true.
-      logical,parameter :: is_mpi_root=.true.
+      real dx3_glo(nbp_lon,nbp_lat,L_NSPECTV) ! to store a global 3D data set
+      real areafi_glo(klon_glo) ! mesh area on global physics grid
+#else
+      real areafi_glo(ngrid) ! mesh area on global physics grid
 #endif
 
@@ -138,4 +124,10 @@
          endif
 
+#ifdef CPP_PARA
+          ! Gather airephy() mesh area on physics grid
+          call Gather(airephy,areafi_glo)
+#else
+         areafi_glo(:)=airephy(:)
+#endif
          ! Create the NetCDF file
          if (is_master) then
@@ -158,8 +150,21 @@
          ierr = NF_ENDDEF(nid)
 
+         ! Build area()
+         do i=1,nbp_lon+1 ! poles
+           ! divide at the poles by nbp_lon
+           area(i,1)=areafi_glo(1)/nbp_lon
+           area(i,nbp_lat)=areafi_glo(klon_glo)/nbp_lon
+         enddo
+         do j=2,nbp_lat-1
+           ig0= 1+(j-2)*nbp_lon
+           do i=1,nbp_lon
+              area(i,j)=areafi_glo(ig0+i)
+           enddo
+           ! handle redundant point in longitude
+           area(nbp_lon+1,j)=area(1,j)
+         enddo
+
          ! write "header" of file (longitudes, latitudes, geopotential, ...)
-!         call gr_fi_dyn(1,ngrid,iip1,jjp1,phisfi,phis)
-!         call iniwrite(nid,day_ini,phis)
-         call iniwrite_specVI(nid,day_ini)
+         call iniwrite_specVI(nid,day_ini,area)
          endif ! of if (is_master)
 
@@ -215,5 +220,5 @@
              endif
 
-             write(6,*)'WRITEDIAGSPEC: date= ', date
+             write(6,*)'WRITEDIAGSPECVI: date= ', date
            endif ! of if (is_master)
         end if ! of if (nom.eq.firstnom)
@@ -233,6 +238,6 @@
             call Grid1Dto2D_glo(dx3_glop,dx3_glo)
             ! copy dx3_glo() to dx3(:) and add redundant longitude
-            dx3(1:iim,:,:)=dx3_glo(1:iim,:,:)
-            dx3(iip1,:,:)=dx3(1,:,:)
+            dx3(1:nbp_lon,:,:)=dx3_glo(1:nbp_lon,:,:)
+            dx3(nbp_lon+1,:,:)=dx3(1,:,:)
           endif
 !$OMP END MASTER
@@ -240,14 +245,14 @@
 #else
            DO l=1,L_NSPECTV
-             DO i=1,iip1
+             DO i=1,nbp_lon+1
                 dx3(i,1,l)=px(1,l)
-                dx3(i,jjp1,l)=px(ngrid,l)
+                dx3(i,nbp_lat,l)=px(ngrid,l)
              ENDDO
-             DO j=2,jjm
-                ig0= 1+(j-2)*iim
-                DO i=1,iim
+             DO j=2,nbp_lat-1
+                ig0= 1+(j-2)*nbp_lon
+                DO i=1,nbp_lon
                    dx3(i,j,l)=px(ig0+i,l)
                 ENDDO
-                dx3(iip1,j,l)=dx3(1,j,l)
+                dx3(nbp_lon+1,j,l)=dx3(1,j,l)
              ENDDO
            ENDDO
@@ -279,6 +284,6 @@
            corner(4)=ntime
 
-           edges(1)=iip1
-           edges(2)=jjp1
+           edges(1)=nbp_lon+1
+           edges(2)=nbp_lat
            edges(3)=L_NSPECTV
            edges(4)=1
Index: /trunk/LMDZ.GENERIC/libf/phystd/wstats.F90
===================================================================
--- /trunk/LMDZ.GENERIC/libf/phystd/wstats.F90	(revision 1528)
+++ /trunk/LMDZ.GENERIC/libf/phystd/wstats.F90	(revision 1529)
@@ -1,22 +1,18 @@
 subroutine wstats(ngrid,nom,titre,unite,dim,px)
 
+use statto_mod, only: istats,istime,count
 use mod_phys_lmdz_para, only : is_mpi_root, is_master, gather, klon_mpi_begin
-use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo
-use statto_mod, only: istats,istime,count
-
+use mod_grid_phy_lmdz, only : klon_glo, Grid1Dto2D_glo, &
+                              nbp_lon, nbp_lat, nbp_lev
 implicit none
 
-#include "dimensions.h"
-!#include "dimphys.h"
-#include "netcdf.inc"
+include "netcdf.inc"
 
 integer,intent(in) :: ngrid
 character (len=*),intent(in) :: nom,titre,unite
 integer,intent(in) :: dim
-integer,parameter :: iip1=iim+1
-integer,parameter :: jjp1=jjm+1
-real,intent(in) :: px(ngrid,llm)
-real, dimension(iip1,jjp1,llm) :: mean3d,sd3d,dx3
-real, dimension(iip1,jjp1) :: mean2d,sd2d,dx2
+real,intent(in) :: px(ngrid,nbp_lev)
+real, dimension(nbp_lon+1,nbp_lat,nbp_lev) :: mean3d,sd3d,dx3
+real, dimension(nbp_lon+1,nbp_lat) :: mean2d,sd2d,dx2
 character (len=50) :: namebis
 character (len=50), save :: firstvar
@@ -34,16 +30,16 @@
 ! Added to work in parallel mode
 #ifdef CPP_PARA
-real px3_glop(klon_glo,llm) ! to store a 3D data set on global physics grid
-real px3_glo(iim,jjp1,llm) ! to store a global 3D data set on global lonxlat grid
+real px3_glop(klon_glo,nbp_lev) ! to store a 3D data set on global physics grid
+real px3_glo(nbp_lon,nbp_lat,nbp_lev) ! to store a global 3D data set on global lonxlat grid
 real px2_glop(klon_glo) ! to store a 2D data set on global physics grid
-real px2_glo(iim,jjp1) ! to store a 2D data set on global lonxlat grid
+real px2_glo(nbp_lon,nbp_lat) ! to store a 2D data set on global lonxlat grid
 real px2(ngrid)
-real px3(ngrid,llm)
+real px3(ngrid,nbp_lev)
 #else
 ! When not running in parallel mode:
-real px3_glop(ngrid,llm) ! to store a 3D data set on global physics grid
-real px3_glo(iim,jjp1,llm) ! to store a global 3D data set on global lonxlat grid
+real px3_glop(ngrid,nbp_lev) ! to store a 3D data set on global physics grid
+real px3_glo(nbp_lon,nbp_lat,nbp_lev) ! to store a global 3D data set on global lonxlat grid
 real px2_glop(ngrid) ! to store a 2D data set on global physics grid
-real px2_glo(iim,jjp1) ! to store a 2D data set on global lonxlat grid
+real px2_glo(nbp_lon,nbp_lat) ! to store a 2D data set on global lonxlat grid
 #endif
 
@@ -67,5 +63,5 @@
 #ifdef CPP_PARA
  if (dim.eq.3) then
-  px3(1:ngrid,1:llm)=px(1:ngrid,1:llm)
+  px3(1:ngrid,1:nbp_lev)=px(1:ngrid,1:nbp_lev)
   ! Gather fieds on a "global" (without redundant longitude) array
   call Gather(px3,px3_glop)
@@ -74,6 +70,6 @@
     call Grid1Dto2D_glo(px3_glop,px3_glo)
     ! copy dx3_glo() to dx3(:) and add redundant longitude
-    dx3(1:iim,:,:)=px3_glo(1:iim,:,:)
-    dx3(iip1,:,:)=dx3(1,:,:)
+    dx3(1:nbp_lon,:,:)=px3_glo(1:nbp_lon,:,:)
+    dx3(nbp_lon+1,:,:)=dx3(1,:,:)
   endif
 !$OMP END MASTER
@@ -87,6 +83,6 @@
             call Grid1Dto2D_glo(px2_glop,px2_glo)
             ! copy px2_glo() to dx2(:) and add redundant longitude
-            dx2(1:iim,:)=px2_glo(1:iim,:)
-            dx2(iip1,:)=dx2(1,:)
+            dx2(1:nbp_lon,:)=px2_glo(1:nbp_lon,:)
+            dx2(nbp_lon+1,:)=dx2(1,:)
           endif
 !$OMP END MASTER
@@ -95,14 +91,14 @@
 #else
   if (dim.eq.3) then
-    px3_glop(:,1:llm)=px(:,1:llm)
+    px3_glop(:,1:nbp_lev)=px(:,1:nbp_lev)
 !  Passage variable physique -->  variable dynamique
-    DO l=1,llm
-      DO i=1,iim
+    DO l=1,nbp_lev
+      DO i=1,nbp_lon
          px3_glo(i,1,l)=px(1,l)
-         px3_glo(i,jjp1,l)=px(ngrid,l)
+         px3_glo(i,nbp_lat,l)=px(ngrid,l)
       ENDDO
-      DO j=2,jjm
-         ig0= 1+(j-2)*iim
-         DO i=1,iim
+      DO j=2,nbp_lat-1
+         ig0= 1+(j-2)*nbp_lon
+         DO i=1,nbp_lon
             px3_glo(i,j,l)=px(ig0+i,l)
          ENDDO
@@ -112,11 +108,11 @@
     px2_glop(:)=px(:,1)
 !    Passage variable physique -->  physique dynamique
-   DO i=1,iim
+   DO i=1,nbp_lon
      px2_glo(i,1)=px(1,1)
-     px2_glo(i,jjp1)=px(ngrid,1)
+     px2_glo(i,nbp_lat)=px(ngrid,1)
    ENDDO
-   DO j=2,jjm
-     ig0= 1+(j-2)*iim
-     DO i=1,iim
+   DO j=2,nbp_lat-1
+     ig0= 1+(j-2)*nbp_lon
+     DO i=1,nbp_lon
         px2_glo(i,j)=px(ig0+i,1)
      ENDDO
@@ -198,10 +194,10 @@
    if (dim.eq.3) then
       start=(/1,1,1,indx/)
-      sizes=(/iip1,jjp1,llm,1/)
+      sizes=(/nbp_lon+1,nbp_lat,nbp_lev,1/)
       mean3d(:,:,:)=0
       sd3d(:,:,:)=0
    else if (dim.eq.2) then
       start=(/1,1,indx,0/)
-      sizes=(/iip1,jjp1,1,0/)
+      sizes=(/nbp_lon+1,nbp_lev,1,0/)
       mean2d(:,:)=0
       sd2d(:,:)=0
@@ -211,5 +207,5 @@
    if (dim.eq.3) then
       start=(/1,1,1,indx/)
-      sizes=(/iip1,jjp1,llm,1/)
+      sizes=(/nbp_lon+1,nbp_lat,nbp_lev,1/)
 #ifdef NC_DOUBLE
       ierr = NF_GET_VARA_DOUBLE(nid,meanid,start,sizes,mean3d)
@@ -226,5 +222,5 @@
    else if (dim.eq.2) then
       start=(/1,1,indx,0/)
-      sizes=(/iip1,jjp1,1,0/)
+      sizes=(/nbp_lon+1,nbp_lat,1,0/)
 #ifdef NC_DOUBLE
       ierr = NF_GET_VARA_DOUBLE(nid,meanid,start,sizes,mean2d)
@@ -245,9 +241,9 @@
 
 if (dim.eq.3) then
-  dx3(1:iim,:,:)=px3_glo(:,:,:)
-  dx3(iip1,:,:)=dx3(1,:,:)
+  dx3(1:nbp_lon,:,:)=px3_glo(:,:,:)
+  dx3(nbp_lon+1,:,:)=dx3(1,:,:)
 else ! dim.eq.2
-  dx2(1:iim,:)=px2_glo(:,:)
-  dx2(iip1,:)=dx2(1,:)
+  dx2(1:nbp_lon,:)=px2_glo(:,:)
+  dx2(nbp_lon+1,:)=dx2(1,:)
 endif
 
@@ -290,41 +286,37 @@
 !======================================================
 subroutine inivar(nid,varid,ngrid,dim,indx,px,ierr)
+use mod_grid_phy_lmdz, only : nbp_lon, nbp_lat, nbp_lev
 
 implicit none
 
-include "dimensions.h"
-!include "dimphys.h"
 include "netcdf.inc"
 
 integer, intent(in) :: nid,varid,dim,indx,ngrid
-real, dimension(ngrid,llm), intent(in) :: px
+real, dimension(ngrid,nbp_lev), intent(in) :: px
 integer, intent(out) :: ierr
-
-integer,parameter :: iip1=iim+1
-integer,parameter :: jjp1=jjm+1
 
 integer :: l,i,j,ig0
 integer, dimension(4) :: start,sizes
-real, dimension(iip1,jjp1,llm) :: dx3
-real, dimension(iip1,jjp1) :: dx2
+real, dimension(nbp_lon+1,nbp_lat,nbp_lev) :: dx3
+real, dimension(nbp_lon+1,nbp_lat) :: dx2
 
 if (dim.eq.3) then
 
    start=(/1,1,1,indx/)
-   sizes=(/iip1,jjp1,llm,1/)
+   sizes=(/nbp_lon+1,nbp_lat,nbp_lev,1/)
 
 !  Passage variable physique -->  variable dynamique
 
-   DO l=1,llm
-      DO i=1,iip1
+   DO l=1,nbp_lev
+      DO i=1,nbp_lon+1
          dx3(i,1,l)=px(1,l)
-         dx3(i,jjp1,l)=px(ngrid,l)
+         dx3(i,nbp_lat,l)=px(ngrid,l)
       ENDDO
-      DO j=2,jjm
-         ig0= 1+(j-2)*iim
-         DO i=1,iim
+      DO j=2,nbp_lat-1
+         ig0= 1+(j-2)*nbp_lon
+         DO i=1,nbp_lon
             dx3(i,j,l)=px(ig0+i,l)
          ENDDO
-         dx3(iip1,j,l)=dx3(1,j,l)
+         dx3(nbp_lon+1,j,l)=dx3(1,j,l)
       ENDDO
    ENDDO
@@ -339,18 +331,18 @@
 
       start=(/1,1,indx,0/)
-      sizes=(/iip1,jjp1,1,0/)
+      sizes=(/nbp_lon+1,nbp_lat,1,0/)
 
 !    Passage variable physique -->  physique dynamique
 
-  DO i=1,iip1
+  DO i=1,nbp_lon+1
      dx2(i,1)=px(1,1)
-     dx2(i,jjp1)=px(ngrid,1)
+     dx2(i,nbp_lat)=px(ngrid,1)
   ENDDO
-  DO j=2,jjm
-     ig0= 1+(j-2)*iim
-     DO i=1,iim
+  DO j=2,nbp_lat-1
+     ig0= 1+(j-2)*nbp_lon
+     DO i=1,nbp_lon
         dx2(i,j)=px(ig0+i,1)
      ENDDO
-     dx2(iip1,j)=dx2(1,j)
+     dx2(nbp_lon+1,j)=dx2(1,j)
   ENDDO
 
@@ -380,5 +372,5 @@
 implicit none
 
-#include "netcdf.inc"
+include "netcdf.inc"
 
 integer,intent(in) :: nid ! NetCDF file ID
